#!/bin/bash
#
# Licensed Materials - Property of IBM
#
# OCO Source Materials
#
# (C) Copyright IBM Corp. 2011 All Rights Reserved
#
# The source code for this program is not published or other-
# wise divested of its trade secrets, irrespective of what has
# been deposited with the U.S. Copyright Office.
#

CLEAR_HOSTVG_COMMAND="/opt/ibm/directorappliance/bin/filestg.sh -a del"
RUN_HYPERVISOR_COMMAND="/opt/ibm/director/vmi/scripts/execWithPrivilege/mgmtNetUtil runcommand "
CLEANUP_HOSTVG="vgreduce --removemissing HostVG" #This should be covered by the filestg.sh, but the worst thing that can happen is this will say HostVG already consistant

lvExists=`$RUN_HYPERVISOR_COMMAND"lvdisplay" | grep vmsnapshot | wc -l`
lvRestoreExists=`$RUN_HYPERVISOR_COMMAND"lvdisplay" | grep Restore | wc -l`

if [ $lvExists -ge 1 ]; then
        #if the LV exists try to remove it
        `$RUN_HYPERVISOR_COMMAND"lvremove -f /dev/HostVG/vmsnapshot"`

        #if the LV still exists fail
        lvExists=`$RUN_HYPERVISOR_COMMAND"lvdisplay" | grep vmsnapshot | wc -l`
        if [ $lvExists -ge 1 ]; then
                exit 1
        fi
fi

if [ $lvRestoreExists -ge 1 ]; then
        #if the LV exists try to remove it
        `$RUN_HYPERVISOR_COMMAND"lvremove -f /dev/HostVG/Restore"`

        #if the LV still exists fail
        lvRestoreExists=`$RUN_HYPERVISOR_COMMAND"lvdisplay" | grep Restore | wc -l`
        if [ $lvRestoreExists -ge 1 ]; then
                exit 1
        fi
fi

$RUN_HYPERVISOR_COMMAND$CLEAR_HOSTVG_COMMAND > /dev/null 2>&1
$RUN_HYPERVISOR_COMMAND$CLEANUP_HOSTVG > /dev/null 2>&1