#!/bin/sh
# gather metrics of memory, disk io and disk space from MCP.

LC_ALL=C

# memory: util, used, free
free | awk '$1~/^-/{print $3/($3+$4),$3,$4}'

# disk io: max util
iostat -dx 10 2 | sed -n '/^Device/,/^\n$/p'| grep -Ev '(^Device|^\n$)' | cut -f 1,2 | awk 'BEGIN{FS="\n";RS=""} NR==2{print}' | awk '{print $12}' | sort | tail -n 1

# disk space: used, available, util and mount on of record with max util. if large file of pe home
df -m | sed '1d' | awk -F" " '{if(NF==1)printf "%s ", $0; else print}'| awk  '{print $3, $4, $5, $6}' | sort -n -k3 | tail -n 1

# if there exist files larger than 500MB in pe home, return 1; Otherwise, return 0.
if [$(find /home/pe -type f -size +500000k -exec ls -lh {} \; | awk '{ print $9 ": " $5 }') == ""]
then
	echo false 
else
	echo true 
fi
