#!/bin/bash
#
# Licensed Materials - Property of IBM
#
# OCO Source Materials
#
# (C) Copyright IBM Corp. 2012 All Rights Reserved
#
# The source code for this program is not published or other-
# wise divested of its trade secrets, irrespective of what has
# been deposited with the U.S. Copyright Office.
#

export PATH=/opt/IBMJava/jre/bin:/usr/bin:/sbin:/usr/sbin:/bin:/usr/smrshbin/:$PATH

LOG_FILE_DIR="/opt/ibm/director/lwi/logs/"

if [[ $# -lt 1 || $# -gt 2 ]];then
	echo "Usage: auditLogger <command name> <command return code>"
	echo "<command name>: the name of the command which called auditLogger"
	exit 1
fi

command=$1
if [[ $# -eq 2 ]]; then
	returnCode=$2
else
	returnCode="0"
fi

user=$(who -m | sed 's/  */\ /g' | cut -d' ' -f 1)
user=${user:-$(id -u -n)}
user=${user:-unknown}
host=$(who -m | sed 's/  */\ /g;s/[(]//;s/[)]//' | cut -d' ' -f 5)

#Some versions of "who" output the dates in different formats, this is to make it more robust
if [[ $(echo $host | grep -P "\d\d:\d\d[^\d]" | wc -l) -ne 0 ]];then
	host=$(who -m | sed 's/  */\ /g;s/[(]//;s/[)]//' | cut -d' ' -f 6)
fi

if [[ $host == "" || $host == ":0.0" ]];then
	host="localhost"
fi

fileList=$(ls -lat $LOG_FILE_DIR | grep -oP -m1 '\.(\w+[_]){2}(.+[_]){2}[-]{0,1}\d+\.log\.\d+')
lastElement=${#fileList[@]}
if [[ $lastElement -gt 0 ]]; then
	lastDigit=$(echo ${fileList[0]} | grep -oP '\d+$')
	lastDigit=$(($lastDigit+1))
else
	lastDigit=1
fi

touch $LOG_FILE_DIR"."$command"_"$user"_"$host"_"$(date +%m#%d#%Y#%H#%M#%S)"_"$returnCode".log."$lastDigit
