#!/bin/sh
#
# Licensed Materials - Property of IBM
#
# OCO Source Materials
#
# (C) Copyright IBM Corp. 2011 All Rights Reserved
#
# The source code for this program is not published or other-
# wise divested of its trade secrets, irrespective of what has
# been deposited with the U.S. Copyright Office.
#
# There can be 1, 2 or 3 parameters passed in.  Order is critical.
# IP address is required and must be the first parameter. Other
# parms are optional.  If you want to specify a Hostname, it MUST
# be parameter 2. If you want to configure the system for NIST 
# Strict mode "parameter.NistStrict" (case sensitive) must be in
# parm 2 or 3 depending on the presence of Hostname.
#
# Parm 1 = IP address
# Parm 2 = Hostname or parameter.NistStrict 
# Parm 3 = parameter.NistStrict
#
# example with 3 parms Nist Strict: 
# bypassLicenseAndSetup.sh 1.2.3.4 system1.ibm.com parameter.NistStrict
# 
# example with 2 parms Nist Strict:
# bypassLicenseAndSetup.sh 1.2.3.4 parameter.NistStrict
#
# example with 2 parms legacy mode (no Nist):
# bypassLicenseAndSetup.sh 1.2.3.4 system1.ibm.com
#
export PATH=/usr/bin:/sbin:/usr/sbin:/bin:$PATH

/opt/ibm/director/vmi/bin/execWithPrivilege auditLogger bypassLicenseAndSetup
NistStrict="off"
if [ $# -eq 1 ]; then
 IP=$1
 Hostname=`hostname`
elif [ $# -eq 2 ]; then
 IP=$1
 if [ $2 = "parameter.NistStrict" ]; then
  NistStrict="on"	
  Hostname=`hostname`
 else
  Hostname=$2
 fi
elif [ $# -eq 3 ]; then 
 IP=$1
 Hostname=$2
 if [ $3 = "parameter.NistStrict" ]; then
  NistStrict="on"
 fi
else
 echo "you must provide either 1 parameter (ip address), 2 parameters (ip address followed by hostname or nist mode) or 3 parameters (ip address, hostname and nist mode)"
 exit 1
fi
echo 'FullHostName='$Hostname>> /opt/ibm/director/vmi/data/.AMInfo.config
echo 'IPAddress='$IP>> /opt/ibm/director/vmi/data/.AMInfo.config
sed -i '/ProductActivation class="ldap/,/<\/ProductActivation/ s/.*//' /opt/ibm/ae/AR/ovf-env.ar
sed -i 's/cfgeth0.ipv4address\" ovfenv:value=\".*"/cfgeth0.ipv4address\" ovfenv:value=\"'${IP}'\"/' /opt/ibm/ae/AP/ovf-env.xml
sed -i 's/ldap.nist\" ovfenv:value=\".*"/ldap.nist\" ovfenv:value=\"'${NistStrict}'\"/' /opt/ibm/ae/AP/ovf-env.xml
#Enable HA for troy
#rm /opt/ibm/director/lwi/runtime/itme/disableHAFunction.sh
#disable Flexcat for Troy
#sed -i 's/FlexCat.service.disabled=false/FlexCat.service.disabled=true/' /opt/ibm/director/lwi/conf/overrides/FlexCat.properties
/opt/ibm/director/vmi/bin/fsmPostLwiUpdatePatches.sh
touch /opt/ibm/director/vmi/data/.wizardcompleted
touch /opt/ibm/director/vmi/data/.licenseaccepted
touch /opt/ibm/director/vmi/data/.troyinstall
/usr/smrshbin/smshutdown -r -t now && sleep 1000
exit 0