#!/bin/bash
#Licensed Materials - Property of IBM
#
# (C) Copyright IBM Corp. 2009, 2011 All Rights Reserved
#
# US Government Users Restricted Rights - Use, duplicate or
# disclosure restricted by GSA ADP Schedule Contract with
# IBM Corp.

# exit 1 Centrally Managed chassis have been found
# exit 0 There are no centrally managed chassis


export TEXTDOMAINDIR=/usr/share/locale
export TEXTDOMAIN=centrallyManagedChassisFound
export PATH=$PATH:/usr/bin:/sbin:/usr/sbin:/bin
. /usr/bin/gettext.sh

#printf "`gettext 'List of centrally managed chassis'`\n\n"

mgchassis=`gettext 'List of centrally managed chassis'`
#mgchassis="List of centrally managed chassis"
#echo "mgchassis is $mgchassis"

none=DNZFM5214I
#if there is no output from the following command then error occurred
smcli lsCentrallyManagedChassis > /tmp/chassis2.txt

error=$(grep Managed /tmp/chassis2.txt)
if [ -z "$error" ]; then
  rm -f /tmp/chassis2.txt 
  echo "FALSE"
  exit 0
fi

	
grep -A 3  "${mgchassis}:" /tmp/chassis2.txt >/tmp/find2.txt

foundline=`grep $none /tmp/find2.txt`
#echo " grep line is $foundline"
rm -f /tmp/chassis2.txt 
rm -f /tmp/find2.txt

if [ "${#foundline}" -eq 0 ]; then
  echo "TRUE"
  exit 1 
else
  echo "FALSE"
  exit 0
fi
exit 

