#! /bin/bash
#
# Licensed Materials - Property of IBM
#
# OCO Source Materials
#
# (C) Copyright IBM Corp. 2013 All Rights Reserved
#
# The source code for this program is not published or other-
# wise divested of its trade secrets, irrespective of what has
# been deposited with the U.S. Copyright Office.
#

export TEXTDOMAINDIR=/usr/share/locale
export TEXTDOMAIN=chHttpTunnel
. /usr/bin/gettext.sh

export PATH=/usr/bin:/bin:$PATH

print_usage (){
	printf "`gettext 'Usage: chEndpointAccess {-E|-D}\n\n\t -E\n\t\t Enable the Endpoint Access option\n\n\t -D\n\t\t Disable the Endoing Access option. All existing tunneled connections will be made invalid'`\n"
	/opt/ibm/director/vmi/bin/execWithPrivilege auditLogger restoreHDD 1
	exit 1
}

CHANGE_COMMAND="chHttpTunnel.sh"

if [[ $# -ne 1 && $1 != "-E" && $1 != "-D" ]];then
	print_usage
fi

/opt/ibm/director/vmi/bin/execWithPrivilege $CHANGE_COMMAND "$@"
rc=$?
/opt/ibm/director/vmi/bin/execWithPrivilege auditLogger chHttpTunnel $rc

if [[ $rc -eq 0 ]];then
	if [[ "$1" == "-E" ]];then
		printf "`gettext 'Successfully enabled Endpoint Access'`\n"
	elif [[ "$1" == "-D" ]];then
		printf "`gettext 'Successfully disabled Endpoint Access'`\n"
	fi
fi
