#! /bin/bash
#
# Licensed Materials - Property of IBM
#
# OCO Source Materials
#
# (C) Copyright IBM Corp. 2013 All Rights Reserved
#
# The source code for this program is not published or other-
# wise divested of its trade secrets, irrespective of what has
# been deposited with the U.S. Copyright Office.
#

export PATH=/usr/bin:/sbin:/usr/sbin:/bin:/usr/smrshbin/:$PATH

CONFIG_FILE_DIR="/etc/xinetd.d/"

port=$2
ip=$1

# Is the IP already being forwarded
ip_exists=$(grep -l $ip $CONFIG_FILE_DIR* | wc -l)
if [[ $ip_exists -gt 0 ]]; then
	# If the port is being forwarded, then is it being forwarded to the port number we were given?
	if [[ $(grep -c $ip $CONFIG_FILE_DIR$port) -gt 0 ]]; then
		exit 1
	fi
	exit 0
fi

if [[ -e $CONFIG_FILE_DIR$port ]]; then 
	exit 0
fi

exit 1
