#!/bin/sh
# Licensed Materials - Property of IBM
#
# (C) Copyright IBM Corp. 2009, 2012 All Rights Reserved
#
# US Government Users Restricted Rights - Use, duplicate or
# disclosure restricted by GSA ADP Schedule Contract with
# IBM Corp.

### BEGIN INIT INFO
# Provides: chnetcfg
# Should-Start:  
# Required-Start: $local_fs $network isdvmiconfig
# Required-Stop:
# Default-Start: 3 5
# Default-Stop: 0 1 2 6
# Short-Description: Provide fsm firewall customization
# Description: Provides initial commands to customize firewall settings
### END INIT INFO


CONFIG_COMPLETION_FILE=/opt/ibm/director/vmi/data/.fsmFirewallInitialized

. /etc/rc.status
rc_reset
case "$1" in
    start)
          if [ ! -f ${CONFIG_COMPLETION_FILE} ]; then               
		/usr/smrshbin/chnetcfg -s remove --app-name http >/dev/null 2>&1
		/usr/smrshbin/chnetcfg -s remove --app-name DPSM_http_redirect >/dev/null 2>&1
		/usr/smrshbin/chnetcfg -s add --app-name snmp >/dev/null 2>&1
                touch $CONFIG_COMPLETION_FILE
          fi 
		;;
    stop)
        ;;
    *)
        echo "usage: $0 {start}"
        exit 1
        ;;
esac
rc_exit

