#! /bin/sh 
#
# Licensed Materials - Property of IBM
# OCO Source Materials
# 
# (C) Copyright IBM Corp. 2011 All Rights Reserved
# The source code for this program is not published or otherwise divested of its 
# trade secrets, irrespective of what has been deposited with the U.S. Copyright Office.
#

export TEXTDOMAINDIR=/usr/share/locale
export TEXTDOMAIN=chnetcfgFSMcheck
. /usr/bin/gettext.sh

DIRECTOR_ROOT=/opt/ibm/director
FRM_LIB=$DIRECTOR_ROOT/lwi/runtime/itme/eclipse/plugins
OSGI_LIB=$DIRECTOR_ROOT/lwi/runtime/core/eclipse/plugins
JAVA_EXE=/opt/IBMJava/jre/bin/java
TOOL_PGM=com.ibm.itme.security.policy.ChnetcfgFSMcheck
TRANSFER_VAL=xxxx
SERVICE_VAL=yyy
STATE_VAL=zzz
APP_NAME=aaaaa
INTERFACE=iiii
ANY_DHCP_PARM=dddd
RET=0

# Need to set the path for the jre/jvm
export PATH=/usr/lib64/jvm/java-1.5.0-ibm/bin:$PATH

DIRECTOR_VERSION=$(grep -i 'smcore.ver'  "/opt/ibm/director/version.srv"   | cut -f2 -d '=')
MESSAGE_UTIL_JAR=/opt/ibm/director/lwi/runtime/USMiResource/eclipse/plugins/com.ibm.director.core.common_$DIRECTOR_VERSION.jar
TOOL_CLASSPATH=$TOOL_CLASSPATH$MESSAGE_UTIL_JAR:

#for f in $( find "$FRM_LIB" -name "*.jar" ); do
#  TOOL_CLASSPATH=$TOOL_CLASSPATH$f:
#done
FSM_VERSION=$(grep -i 'FSMversion=' "/opt/ibm/director/lwi/runtime/itme/properties/FRM.version.properties"   | cut -f2 -d '=' | grep -v FSMversion)
FSM_COMMON_JAR=/opt/ibm/director/lwi/runtime/itme/eclipse/plugins/com.ibm.itme.common_$FSM_VERSION/classes/common.jar
FSM_UTIL_JAR=/opt/ibm/director/lwi/runtime/itme/eclipse/plugins/com.ibm.itme.utils_$FSM_VERSION/classes/utils.jar
FSM_SECURITY_JAR=/opt/ibm/director/lwi/runtime/itme/eclipse/plugins/com.ibm.itme.security_$FSM_VERSION/classes/security.jar
FSM_TASKS_JAR=/opt/ibm/director/lwi/runtime/itme/eclipse/plugins/com.ibm.itme.tasks_$FSM_VERSION/classes/tasks.jar
FSM_USERMGMT_JAR=/opt/ibm/director/lwi/runtime/itme/eclipse/plugins/com.ibm.itme.usermgmt_$FSM_VERSION/classes/com.ibm.itme.usermgmt.jar
ASPECTJ_JAR=/opt/ibm/director/lwi/runtime/itme/eclipse/plugins/com.ibm.itme.common_$FSM_VERSION/aspectjrt.jar

FSM_JARS=$FSM_SECURITY_JAR:$FSM_UTIL_JAR:$FSM_TASKS_JAR:$FSM_USERMGMT_JAR:$FSM_COMMON_JAR:$ASPECTJ_JAR:

CORE_KERNEL_JAR=/opt/ibm/director/lwi/runtime/USMiMain/eclipse/plugins/com.ibm.director.core.kernel_$DIRECTOR_VERSION/classes/core-kernel.jar
TOOL_CLASSPATH=$FSM_JARS:$CORE_KERNEL_JAR:$MESSAGE_UTIL_JAR:

#echo "classpath is $TOOL_CLASSPATH"

while [ "$#" -ne "0" ]; do
    case $1 in
     -t)     TRANSFER_VAL=$2 
             ;;
     -c)     SERVICE_VAL=$2 
             ;;
     -s)     STATE_VAL=$2 
             ;;
    --app-name)  APP_NAME=$2 
             ;;
    -i)      INTERFACE=$2 
             ;;
    --start-ip-address)  ANY_DHCP_PARM=$2 
             ;;
    --dhcp-client)  ANY_DHCP_PARM=$2 
             ;;

    esac
    shift
done
#echo "*****************New Entry*******************" >> /home/checkfsm.log

# Call the java program 
OPT1=-Djava.util.logging.config.file=/opt/ibm/director/itme/logging.properties
OPT2="-Xdebug -Xrunjdwp:transport=dt_socket,address=8001,server=y,suspend=y"

#echo "command is $JAVA_EXE -cp $TOOL_PGM $SERVICE_VAL $STATE_VAL $TRANSFER_VAL $APP_NAME $INTERFACE $ANY_DHCP_PARM || RET=$?"
#$JAVA_EXE -cp  $TOOL_CLASSPATH $TOOL_PGM $SERVICE_VAL $STATE_VAL $TRANSFER_VAL $APP_NAME $INTERFACE $ANY_DHCP_PARM || RET=$? 
$JAVA_EXE  -cp  $TOOL_CLASSPATH $TOOL_PGM $SERVICE_VAL $STATE_VAL $TRANSFER_VAL $APP_NAME $INTERFACE $ANY_DHCP_PARM || RET=$? 

if [ $RET -ne 1 ];
then
#printf "`gettext 'SUCCESS - Parameters are OK'`\n"
exit 0
else
#printf "`gettext 'FAILED - Parameters need to be secure'`\n"

exit 1
fi
