#!/bin/bash
# Licensed Materials - Property of IBM
#
# (C) Copyright IBM Corp. 2011, 2011 All Rights Reserved
#
# US Government Users Restricted Rights - Use, duplicate or
# disclosure restricted by GSA ADP Schedule Contract with
# IBM Corp.

#This script is used to comments out entries related
# to ldap processes in /etc/inittab to prevent it from automatically
# being spawned off. 
# located at /opt/ibm/director/vmi/scripts/execWithPrivilege/disableLdapWatchdog.sh

#######disableLdapWatchdog.sh

PID=
LOG=/var/log/disableldapwatchdog
date >$LOG
rc=1

cp /etc/inittab /etc/inittab.bk
#comment out the line from etc/inittab
perl -pi -e "s/^ldap:2345/#ldap:2345/g" /etc/inittab
# refresh the init task so it no longer respawns the server
init q

#kill createLdapWatchdog process if there is any
 PID=`ps aux |grep "createLdapWatchdog"|grep -v grep|awk '{print $2}'`
 echo "Pid:$PID" >>$LOG
 if [ -z "$PID" ]; then 
  echo "No createLdapWatchdog Pid" >>$LOG
 else
  kill $PID >>$LOG
  echo "Killed createLdapWatchdog process $PID" >>$LOG
 fi
 
 # stop service and remove it from OS control
  /sbin/chkconfig --del ldap >/dev/null 2>>$LOG
  rc=$?
  #stop_out=`/etc/init.d/ldap stop`
  #echo "/etc/init.d/ldap stop: output: ${stop_out} : rc: $rc"
	      
exit $rc