#!/bin/bash
if [ -f /opt/ibm/director/vmi/data/.postLwiUpdatesApplied ]; then
	exit 1
fi
touch /opt/ibm/director/vmi/data/.postLwiUpdatesApplied
itmeDir=/opt/ibm/director/lwi/runtime/itme
pluginsDir=$itmeDir/eclipse/plugins
# Source the FRM version properties.
. $itmeDir/properties/FRM.version.properties

#run console descoping scripts to disable function by default:
# echo "disabling descoped function for GA1"

$itmeDir/disableHAFunction.sh
$itmeDir/disableAEMFunction.sh

if [ -z "$(cat /opt/ibm/director/data/ChassisManager/extension.properties | grep 'auto.request.access=disabled')" ]; then
	echo -e "\nauto.request.access=disabled" >> /opt/ibm/director/data/ChassisManager/extension.properties
fi
if [ -n "$(cat /opt/ibm/director/lwi/runtime/itme/DescopedFunction.properties | grep 'AEM=false')" ]; then
# AEM is disabled, so we need to make sure an AEM update didn't enable it back
	if [ -z "$(cat /opt/ibm/director/proddata/advmgr/AEM.properties | grep '#activation-bundle=com.ibm.aem.activator_1.0.0.jar')" ]; then
		# the line was not commented out, which means AEM enabled it back, comment it out again.
		sed -i 's/activation-bundle=com.ibm.aem.activator_1.0.0.jar/#activation-bundle=com.ibm.aem.activator_1.0.0.jar/g' /opt/ibm/director/proddata/advmgr/AEM.properties
	fi
fi
#networking changes:

if [ -z "$(cat /etc/sysctl.conf | grep 'net.ipv4.conf.all.arp_filter')" ]; then
	echo "net.ipv4.conf.all.arp_filter = 1" >> /etc/sysctl.conf
fi	
if [ -z "$(cat /etc/sysctl.conf | grep 'net.ipv4.conf.default.arp_filter')" ]; then
	echo "net.ipv4.conf.default.arp_filter = 1" >> /etc/sysctl.conf
fi	

#Remove genesis script since we no longer need it

rm /etc/init.d/activation.createFSMnetwork
rm /etc/init.d/boot.d/S11activation.createFSMnetwork

#setup wizard changes:

# 4. Modify smlaunchwizard to not launch browser (browser will be launched by lap instead) and notwait for browser to end
echo "Modifying smlaunchwizard to not launch and depend on browser"
sed -i 's/${VMI_BIN_DIR}\/launchBrowser/rm -f ${WIZARD_EXIT_STATUS_FILE}\nWIZARD_FINISHED_FILE=\/opt\/ibm\/director\/vmi\/data\/.redirectwizard\n&/' /opt/ibm/director/vmi/bin/smlaunchwizard
sed -i 's/SETUP_WIZARD_BROWSER_PID=/# &/'  /opt/ibm/director/vmi/bin/smlaunchwizard
sed -i 's/echo \"The PID of/# &/'  /opt/ibm/director/vmi/bin/smlaunchwizard
sed -i 's/while \[ "${SETUP_WIZARD_BROWSER_PID}" != "" ]/while [ ! -f ${WIZARD_FINISHED_FILE} ]/'  /opt/ibm/director/vmi/bin/smlaunchwizard
sed -i  '/SETUP_WIZARD_BROWSER/,/sleep 5/ s/sleep 5/&\nif [ -r ${WIZARD_EXIT_STATUS_FILE} ]; then\nWIZARD_EXIT_STATUS=`cat ${WIZARD_EXIT_STATUS_FILE}`\nif [ ${WIZARD_EXIT_STATUS} == "1" -o ${WIZARD_EXIT_STATUS} == "2" ] ; then\nbreak\nfi\nfi/ ' /opt/ibm/director/vmi/bin/smlaunchwizard
sed -i  '/4 )/,/\* )/ s/\/usr\/smrshbin\/smshutdown -t now/\necho y | \/usr\/smrshbin\/resetwizard.sh\ntouch \/opt\/ibm\/director\/vmi\/data\/.licenseaccepted\n\/usr\/smrshbin\/smshutdown -r -t now/' /opt/ibm/director/vmi/bin/smlaunchwizard
sed -i 's/# Launching browser/NETWORK_VALIDATION_ERROR=\/opt\/ibm\/director\/vmi\/data\/networkValidation.error\nif [ -f ${NETWORK_VALIDATION_ERROR} ]; then\ncd \/opt\/ibm\/director\/lwi\/runtime\/SetupWizard\/eclipse\/plugins\/com.ibm.vmi.setupwizard.framework_*\ncp theme\/img\/background.jpg theme\/img\/networkError.jpg\nWIZARD_URL=$PROTOCOL:\/\/localhost:$PORT\/ibm\/console\nfi\n&/' /opt/ibm/director/vmi/bin/smlaunchwizard	
sed -i 's/LWI_START_OPTION=\"profile.setupwizard=uimin,uistandard,SetupWizard com.ibm.lwi.profile=profile.setupwizard $PORT_OPTION_FOR_LWI/LWI_START_OPTION=\"profile.setupwizard=uimin,uistandard,SetupWizard,rest com.ibm.lwi.profile=profile.setupwizard/' /opt/ibm/director/vmi/bin/smlaunchwizard
# 8. Copy and replace jsps
echo "Copy and replace jsps"
# SETUPWIZARD=/opt/ibm/director/lwi/runtime/SetupWizard/eclipse/plugins/com.ibm.vmi.setupwizard.framework_${CSDA_setupWizardVersion}
# SETUPWIZARDJSP=$SETUPWIZARD/WEB-INF/classes/_ibmjsp	
# cd $SETUPWIZARDJSP/
# wizardFolder=/opt/ibm/director/lwi/runtime/SetupWizard/eclipse/plugins/com.ibm.itme.setupwizard.pages_${setupwizardPagesVersion}
# cp -P $wizardFolder/WEB-INF/classes/_ibmjsp/_FinishPage.class ./
# cp -P $wizardFolder/WEB-INF/classes/_ibmjsp/_serverStatus.class ./
# cp -P $wizardFolder/WEB-INF/classes/_ibmjsp/_wizardError.class ./

#Copy other files
scriptsFolder=/opt/ibm/director/lwi/runtime/SetupWizard/eclipse/plugins/com.ibm.itme.setupwizard.pages_${setupwizardPagesVersion}/
# cd $SETUPWIZARD/
# cp -P $scriptsFolder/faces-config.xml ./WEB-INF/
SETUPWIZARDPLUGIN=/opt/ibm/director/lwi/runtime/SetupWizard/eclipse/plugins/com.ibm.vmi.setupwizard.pluginpages_${CSDA_setupWizardVersion}
cd $SETUPWIZARDPLUGIN/	
cp -P $scriptsFolder/CSDAplugin.xml ./plugin.xml

#end setupwizard changes
	
#Function appendRoles is used to append predefined roles and groups to director configuration files
#If the SMDefault role is already in the file, this step is skipped.
function appendRoles()
{
directorRolesFile=$1
userMgmtRolesFile=$2
tag=$3
num=`grep -c 'SMDefault' $directorRolesFile`
if [ "$num" = "0" ] 
then
	echo "Updating FSM  roles in $directorRolesFile"
	echo "Appending file[$userMgmtRolesFile]"
    sed -i s:$tag:' ':g $directorRolesFile
	cat $userMgmtRolesFile >> $directorRolesFile
	echo "$tag" >> $directorRolesFile
fi
}

# Copy file for FRM roles to proddata and data directories
directorDir=/opt/ibm/director/proddata/defaults
userMgmtDir=/opt/ibm/director/lwi/runtime/itme/eclipse/plugins/com.ibm.itme.usermgmt_${usermgmtVersion}
echo "Copy $userMgmtDir/ibm-sys-roles-fsm.xml to $directorDir"
cp -P $userMgmtDir/ibm-sys-roles-fsm.xml $directorDir
appendRoles $directorDir/ibm-user-groups.xml $userMgmtDir/FrmUserGroups "</ibm-def-groups>"

#Change ibm-def-groups updated="false" to "true" ibm-user-groups.xml
sed -i 's/ibm-def-groups updated="false"/ibm-def-groups updated="true"/' $directorDir/ibm-user-groups.xml

directorDir=/opt/ibm/director/data
echo "Copy $userMgmtDir/ibm-sys-roles-fsm.xml to $directorDir"
cp -P $userMgmtDir/ibm-sys-roles-fsm.xml $directorDir
appendRoles $directorDir/ibm-user-groups.xml $userMgmtDir/FrmUserGroups "</ibm-def-groups>"

#Change ibm-def-groups updated="false" to "true" in ibm-user-groups.xml
sed -i 's/ibm-def-groups updated="false"/ibm-def-groups updated="true"/' $directorDir/ibm-user-groups.xml

# add usermanagement scripts to the role_permission.xml file
sed -i 's/\(\s*\)<name>smadmin<\/name>/&\n\1<permission id="resetToLocal"\/>\n\1<permission id="chlocalpwd"\/>\n\1<permission id="enablePEonFSM"\/>\n\1<permission id="enableLdapWatchdog"\/>\n\1<permission id="disableLdapWatchdog"\/>\n\1<permission id="slpcheckBackend.sh"\/>\n\1<permission id="foundationsFinishSetup"\/>/' /opt/ibm/director/vmi/data/conf/role_permission.xml

# Configure ftp daemon
echo "Configure ftp for use in Legacy Security mode"
sed -i 's/#local_enable=YES/local_enable=YES/g' /etc/vsftpd.conf
sed -i 's/anonymous_enable=YES/anonymous_enable=NO/g' /etc/vsftpd.conf
sed -i 's/anon_world_readable_only=YES/anon_world_readable_only=NO/g' /etc/vsftpd.conf
# End ftp configuration

# Change firewall ports that were configured by CSDA and DPSM
setupDir=/opt/ibm/director/lwi/runtime/SetupWizard/eclipse/plugins/com.ibm.itme.setupwizard.pages_${setupwizardVersion}
cp $setupDir/chnetcfg.sh /etc/init.d/chnetcfg
chmod 500 /etc/init.d/chnetcfg
chkconfig --add chnetcfg
echo "Configure snmp for use in Secure mode"
chkconfig snmpd on
service snmpd start
#disable non secure SNMPv1 and v2
echo "snmp.trap.v1.enabled=false" >> /opt/ibm/director/data/snmp/SNMPServer.properties
echo "snmp.trap.v2.enabled=false" >> /opt/ibm/director/data/snmp/SNMPServer.properties
# End changing firewall ports


# No language patch
cp -P $scriptsFolder/nolangpatch.jar.patch /opt/ibm/director/lwi/runtime/core/eclipse/plugins/com.ibm.pvc.webcontainer_6.2.3.20131011-0530/nolangpatch.jar
sed -i 's/Bundle-ClassPath: webcontainer.jar/Bundle-ClassPath: .\/nolangpatch.jar,webcontainer.jar/' /opt/ibm/director/lwi/runtime/core/eclipse/plugins/com.ibm.pvc.webcontainer_6.2.3.20131011-0530/META-INF/MANIFEST.MF
#echo 'IgnoreAcceptLanguage=true' > /opt/ibm/director/lwi/conf/overrides/nolang.properties

# Activate VMControl if they have a FoD key for it
echo `date` >> /opt/ibm/vmi/data/fsmPostLwiUpdatePatches.log

echo "Expand ASU rpm" >> /opt/ibm/vmi/data/fsmPostLwiUpdatePatches.log
rpm -Uvh /opt/ibm/director/lwi/runtime/itme/eclipse/plugins/com.ibm.itme.licensemgmt_${licensemgmtVersion}/ASU/ibm_utl_asu_asut76p-9.00_linux_x86-64.rpm >> /opt/ibm/vmi/data/fsmPostLwiUpdatePatches.log

echo "Copy ASU tool to REVH" >> /opt/ibm/vmi/data/fsmPostLwiUpdatePatches.log
/opt/ibm/director/vmi/scripts/execWithPrivilege/mgmtNetUtil runcommand mkdir -m 755 -p /usr/tmp/toolscenter/asu/rdcli-x86_64 >> /opt/ibm/vmi/data/fsmPostLwiUpdatePatches.log
/opt/ibm/director/vmi/scripts/execWithPrivilege/mgmtNetUtil copyfiletohost /opt/ibm/toolscenter/asu/asu64 /usr/tmp/toolscenter/asu/asu64 >> /opt/ibm/vmi/data/fsmPostLwiUpdatePatches.log

echo "Check for VMControl key" >> /opt/ibm/vmi/data/fsmPostLwiUpdatePatches.log
if [ -n "$(/opt/ibm/director/vmi/scripts/execWithPrivilege/mgmtNetUtil runcommand /usr/tmp/toolscenter/asu/asu64 fodcfg reportkey --device IMM --interface KCS | grep -i 'VMControl\|Advanced Upgrade')" ]; then
  echo "VMControl entitlement found, activating VMControl" >> /opt/ibm/vmi/data/fsmPostLwiUpdatePatches.log
  cp /opt/ibm/director/proddata/advmgr/com.ibm.vmcontrol.activator*.jar /opt/ibm/director/lwi/runtime/Activations/eclipse/plugins >> /opt/ibm/vmi/data/fsmPostLwiUpdatePatches.log
else
  echo "No VMC entitlement found." >> /opt/ibm/vmi/data/fsmPostLwiUpdatePatches.log
  /opt/ibm/director/vmi/scripts/execWithPrivilege/mgmtNetUtil runcommand /usr/tmp/toolscenter/asu/asu64 fodcfg reportkey --device IMM --interface KCS >> /opt/ibm/vmi/data/fsmPostLwiUpdatePatches.log
fi 

#delete manufacturing script
rm /usr/smrshbin/configNetworkForMf.sh > /dev/null 2>&1	

#delete Troy script
rm /usr/smrshbin/bypassLicenseAndSetup.sh > /dev/null 2>&1	

#Update Director auditing with SDMC category. We do this here because we are fixing up DPSM for the Nov 2012 release. Director
#   has defect XB135955 to fix the extension of auditing in the 2Q13 release and then we should be removing SDMC and FSM from
#   this fixup script.
sed -i~ 's/event.filter.type.4=IBMSystemsDirectorProgram.Audit.SDMC//g; ' /opt/ibm/director/classes/extensions/Audit.TWGSimpleEventFilterExt
sed -i~ "\$aevent.filter.type.7=IBMSystemsDirectorProgram.Audit.SDMC" /opt/ibm/director/classes/extensions/Audit.TWGSimpleEventFilterExt

#Update Director auditing with FSM category. We do this here because DPSM appends themselves to the file too. See XB135955
sed -i '$ a\event.filter.type.8=IBMSystemsDirectorProgram.Audit.FSM' /opt/ibm/director/classes/extensions/Audit.TWGSimpleEventFilterExt
auditingDataDir=/opt/ibm/director/data
auditingPluginDir=/opt/ibm/director/lwi/runtime/itme/eclipse/plugins/com.ibm.itme.audit_${auditVersion}
echo "Copy $auditingPluginDir/ibm-auditcat-actions-fsm.xml to $auditingDataDir"
cp -P $auditingPluginDir/ibm-auditcat-actions-fsm.xml $auditingDataDir

exit 0