#!/bin/bash
#Licensed Materials - Property of IBM
#
# (C) Copyright IBM Corp. 2009, 2011 All Rights Reserved
#
# US Government Users Restricted Rights - Use, duplicate or
# disclosure restricted by GSA ADP Schedule Contract with
# IBM Corp.

# exit 1 Managed chassis have been found
# exit 0 There are no managed chassis


export TEXTDOMAINDIR=/usr/share/locale
export TEXTDOMAIN=managedChassisFound
export PATH=$PATH:/usr/bin:/sbin:/usr/sbin:/bin
. /usr/bin/gettext.sh

#printf "`gettext 'Managed Chassis'`\n\n"

mgchassis=`gettext 'Managed Chassis'`
#echo "msgchassis is $msgchassis"
 # Wait for None to be translated before using this variable
 #none=`gettext '\nNone'`
none=None

#if there is no output from the following command then error occurred
smcli lsChassis > /tmp/chassis.txt

error=$(grep Managed /tmp/chassis.txt)
if [ -z "$error" ]; then
  rm -f /tmp/chassis.txt 
  echo "FALSE"
  exit 0
fi

grep -A 3  "${mgchassis}:" /tmp/chassis.txt >/tmp/find.txt

foundline=`grep $none /tmp/find.txt`
#echo " grep line is $foundline"
rm -f /tmp/chassis.txt 
rm -f /tmp/find.txt

if [ "${#foundline}" -eq 0 ]; then
  echo "TRUE"
  exit 1 
else
  echo "FALSE"
  exit 0
fi
exit 

