#!/bin/sh
# Updates the plugin.xml files for all itme plugins.  Assumes messages are in doc.zip in the base plugin directory.
# com.ibm.itme.help and com.ibm.itme.test are excluded
# assumes all html is in  doc.zip under the plugin base directory
# 
# find the plugin files but exclude .help and .test
find /opt/ibm/director/lwi/runtime/itme -name plugin.xml | grep -v ".help" | grep -v ".test" > plugins.lst
# strip off plugin.xml so we just have the path
sed -i 's/plugin.xml/ /'  plugins.lst
#create a temp variable
pluginlist=`cat plugins.lst`
#remove the temp file
rm plugins.lst
# Process each plugin 
for pluginxml in ${pluginlist[*]}
do
 doczip=${pluginxml}doc.zip
 pluginxml=${pluginxml}plugin.xml
 echo "doczip = $doczip"
	
 if [ -f $doczip ]; then
    echo "found $doczip"
	#unzip the doc.zip to get all the html files
	unzip -q $doczip
	#create a temp file with all html file names
	ls DNZ*.html  >> msglist.txt 
	#delete the html files since we don't need them anymore
	rm DNZ*.html
	#remove the '.html' from the message file names.  we just need the message id.
	sed -i 's/.html/ /'  msglist.txt
	#create a temp variable with all the message ids in it
	msglist=`cat msglist.txt`
	#remove the temp file
	rm msglist.txt 
	#create temp file for lines we will eventually insert into plugin.xml
	touch msgs2insert
	#process each message id in the list
	for msgid in ${msglist[*]}
	do
	 #append the approriate line for this msgid to the msgs2insert temp file
	 echo '<task id="'$msgid'" topicId="'$msgid'" />' >> msgs2insert
	done
	
	#search plugin.xml for where we want to insert the lines created above.
	startline=`grep -n 'Beginning of messages' $pluginxml | cut -d ':' -f1`
	endline=`grep -n 'End of messages' $pluginxml | cut -d ':' -f1`
	
	#copy the first part of plugin.xml
	head -n $startline $pluginxml > newplugin.xml
	#insert the new lines for all the messages
	cat msgs2insert >> newplugin.xml
	#delete the msgs2insert temp file
	rm msgs2insert
	#copy the rest of the plugin.xml
	tail -n +$endline $pluginxml >> newplugin.xml
	
	#delete the old plugin.xml
	rm $pluginxml
	#rename the newly created one to take its place
	mv newplugin.xml $pluginxml
 fi 
done

 
