#! /bin/bash 
#
# Licensed Materials - Property of IBM
# OCO Source Materials
# 
# (C) Copyright IBM Corp. 2011 All Rights Reserved
# The source code for this program is not published or otherwise divested of its 
# trade secrets, irrespective of what has been deposited with the U.S. Copyright Office.
#
# Description: This script customizes VMI for FSM.  This script is call from installITME.sh (image build time) and
#              installFSMupdate.sh (update install time) 
#
# Change Activity:
#   10/15/2012 Denney    Initial version
#
itmeDir=/opt/ibm/director/lwi/runtime/itme
pluginsDir=$itmeDir/eclipse/plugins
directorItmeDir=/opt/ibm/director/itme

# This will define several version properties for this script
# See FRM.version.properties in com.ibm.itme.build/properties for a list of properties that are defined
# The build of the FSM GUI Plugins update package includes FRM.version.properties file
echo "***** Include FRM.version.properties file *****" 
chmod 755 /opt/ibm/director/lwi/runtime/itme/properties/FRM.version.properties
. /opt/ibm/director/lwi/runtime/itme/properties/FRM.version.properties


#remove existing ISC files
rm -r /opt/ibm/director/itme/branding/WEB-INF/classes
rm /opt/ibm/director/itme/branding/com.ibm.isclite*.jar

#move FRM brand files to correct location in Director
itmeConsoleBrandPath=$pluginsDir/com.ibm.itme.console.brand_${consoleBrandVersion}
echo "moving $itmeConsoleBrandPath/00_baseFRMCustom to $vmiCustomPath"
vmiCustomPath=/opt/ibm/vmi/customize/postinst.d
rm $vmiCustomPath/00_baseFRMCustom
mv $itmeConsoleBrandPath/00_baseFRMCustom $vmiCustomPath
chmod 550 $vmiCustomPath/00_baseFRMCustom
echo "removing $vmiCustomPath/00_baseDPSMCustom "
rm $vmiCustomPath/00_baseDPSMCustom 

rm /opt/ibm/director/vmi/bin/FSMChangeDefaultPage
mv $itmeConsoleBrandPath/FSMChangeDefaultPage /opt/ibm/director/vmi/bin/
chmod 755 /opt/ibm/director/vmi/bin/FSMChangeDefaultPage

FRMbrandImagePath=$directorItmeDir/branding/images
echo " moving $itmeConsoleBrandPath/*.gif to $FRMbrandImagePath"
mkdir -p $FRMbrandImagePath
rm $FRMbrandImagePath/*.gif
mv $itmeConsoleBrandPath/*.gif $FRMbrandImagePath
echo " moving $itmeConsoleBrandPath/*.png to $FRMbrandImagePath"
rm $FRMbrandImagePath/*.png
mv $itmeConsoleBrandPath/*.png $FRMbrandImagePath

FRMbrandWebInfPath=$directorItmeDir/branding/WEB-INF/lib/com/ibm/isclite/common
echo " moving $itmeConsoleBrandPath/Brands_en.properties to $FRMbrandWebInfPath"
mkdir -p $FRMbrandWebInfPath
rm $FRMbrandWebInfPath/Brands_en.properties
mv $itmeConsoleBrandPath/Brands_en.properties $FRMbrandWebInfPath
echo "Brand files moved."
