#!/bin/bash
#
# Licensed Materials - Property of IBM
#
# OCO Source Materials
#
# (C) Copyright IBM Corp. 2011 All Rights Reserved
#
# The source code for this program is not published or other-
# wise divested of its trade secrets, irrespective of what has
# been deposited with the U.S. Copyright Office.
#

source /opt/ibm/director/lwi/runtime/itme/eclipse/plugins/bin/RGFunctions.sh
FSM_BACKUP_LOG="/var/log/fsm_backuplog"
PID_FILE=/var/run/slapd/slapd.pid

# 0 HA is active
# 3 HA is passive
# 4 HA is not configured
# Run get HA status
echo "Stopping LDAP for backup." >> $FSM_BACKUP_LOG 2>&1
/opt/ibm/director/vmi/scripts/execWithPrivilege/smhapstatus.sh  &>/dev/null
HArc=$?
# Simply stop LDAP for unconfigured HA
if [ $HArc -eq 4 ]; then
	echo "HA node is unconfigured" >> $FSM_BACKUP_LOG 2>&1
	/etc/init.d/ldap stop >> $FSM_BACKUP_LOG 2>&1
else
	# For active HA, turn RG offline.
	if [ $HArc -eq 0 ]; then
		#Exit Status for chrg command
		# 0 Command has run successfully.
		# 1 Error occurred with RMC. 
		# 2 Error occurred with CLI script. 
		# 3 Incorrect flag on command line.
		echo "HA node is active" >> $FSM_BACKUP_LOG
		chrg -o offline $RGname >> $FSM_BACKUP_LOG 2>&1
		wait_for_rg_offline 
		RC=$?
		echo "Wait for ldap to go offline returned $RC" >> $FSM_BACKUP_LOG 2>&1
		if [ $RC -eq 0 ]; then
   			echo "ldap server is offline" >> $FSM_BACKUP_LOG 2>&1
		else
  			echo "ldap server failed to go offline" >> $FSM_BACKUP_LOG 2>&1
		fi
	fi
fi
  	
# For passive node, don't do anything.
if [ $HArc -eq 3 ]; then
	echo "HA node is passive" >> $FSM_BACKUP_LOG 2>&1
fi
 		
# Check if LDAP server is still running, if it is, exit with error.
if  [ -f $PID_FILE ]; then
  echo "Cannot stop ldap server! Exit backup" >> $FSM_BACKUP_LOG 2>&1
  exit 1
fi
