#!/bin/bash
#
# Licensed Materials - Property of IBM
#
# OCO Source Materials
#
# (C) Copyright IBM Corp. 2011 All Rights Reserved
#
# The source code for this program is not published or other-
# wise divested of its trade secrets, irrespective of what has
# been deposited with the U.S. Copyright Office.
#

export TEXTDOMAINDIR=/usr/share/locale
export TEXTDOMAIN=deleteBackupCmd
export PATH=/usr/bin:/bin:$PATH
. /usr/bin/gettext.sh

export PATH=/usr/bin:/sbin:/usr/sbin:/bin:/usr/smrshbin/:$PATH

EXEC_WITH_PRIVILEGE="/opt/ibm/director/vmi/bin/execWithPrivilege"

print_usage() {
	printf "`gettext 'Usage: deleteBackup {backup file name}\n\nExample:\n  deleteBackup 20110110131235.tar.gz'`\n"
	exit 2
}

if [ $# -lt 1 ]; then
	print_usage
fi

if [ "$1" = "-h" -o "$1" = "--help" -o "$1" = "-?" ]; then
	print_usage
fi 

backupName=$1
backupLog=$($EXEC_WITH_PRIVILEGE listBackupsScript.sh | grep -i -- $backupName | cut -d'$' -f 2)
backupType=$(echo $backupLog | cut -d'_' -f 3)

if [[ "$backupType" == "hdd" || $(echo $backupLog | grep -i log | wc -l) -eq 0 ]]; then
	backupType="-d"
	if [[ $(echo $backupLog | grep -i log | wc -l) -eq 0 ]];then
		backupLog="noLog"
	fi
elif [[ "$backupType" == "ftp" ]]; then
	backupType="-f"
elif [[ "$backupType" == "usb" ]]; then
	backupType="-u"
fi

$EXEC_WITH_PRIVILEGE deleteBackup.sh $backupType $backupName -l $backupLog > /dev/null 2>&1
