#! /bin/bash
#
# Licensed Materials - Property of IBM
#
# OCO Source Materials
#
# (C) Copyright IBM Corp. 2011 All Rights Reserved
#
# The source code for this program is not published or other-
# wise divested of its trade secrets, irrespective of what has
# been deposited with the U.S. Copyright Office.
#

#
#Valid options -r, -a
#	-r command_name: Removes the line containing the given command from crontab
#	-a string: Applies the properly formatted string to crontab

FSM_BACKUP_LOG="/var/log/fsm_backuplog"

die () {
    echo >&2 "$@"
    exit 1
}
[ "$#" -eq 2 ] || die "2 arguments required, $# provided"

[ "$1" == "-r" ] || [ "$1" == "-a" ] || die "An invalid option was given -r or -a expected, but got $1"

crontab -l | grep -vP "^# " > my.cron

echo $(date) >> $FSM_BACKUP_LOG 2>&1
echo "=========implementCron.sh args: $1 and $2 =========" >> $FSM_BACKUP_LOG 2>&1
echo "=========Current crontab jobs=========" >> $FSM_BACKUP_LOG 2>&1
cat my.cron >> $FSM_BACKUP_LOG 2>&1

if [ "$1" == "-a" ]; then
	echo "$2" >> my.cron 
	crontab my.cron
	echo "=========Adding a crontab job=========" >> $FSM_BACKUP_LOG 2>&1
	cat my.cron >> $FSM_BACKUP_LOG 2>&1
	rm -f my.cron
elif [ "$1" == "-r" ]; then
	grep -v "$2" my.cron > my.cron2
	crontab my.cron2
	echo "=========Removing a crontab job=========" >> $FSM_BACKUP_LOG 2>&1
	cat my.cron2 >> $FSM_BACKUP_LOG 2>&1
	rm my.cron2
	rm my.cron
fi
