#!/bin/bash

#
# Licensed Materials - Property of IBM
#
# OCO Source Materials
#
# (C) Copyright IBM Corp. 2011 All Rights Reserved
#
# The source code for this program is not published or other-
# wise divested of its trade secrets, irrespective of what has
# been deposited with the U.S. Copyright Office.
#

export TEXTDOMAINDIR=/usr/share/locale
export TEXTDOMAIN=listBackups
export PATH=/usr/bin:/sbin:/usr/sbin:/bin:/usr/smrshbin/:$PATH
. /usr/bin/gettext.sh

print_usage (){
	printf "`gettext 'List the FSM backup files and types.'`\n"
	printf "`gettext 'Usage: listBackups \n\nExample:\n  listBackups '`\n"
	/opt/ibm/director/vmi/bin/execWithPrivilege auditLogger listBackups 1
}

# print help
if [ "$1" = "-h" -o "$1" = "--help" -o "$1" = "-?" ]; then
	print_usage
	exit 0
fi 

backups=$(/opt/ibm/director/vmi/bin/execWithPrivilege listBackupsScript.sh)

if [ -z "$backups" ]; then
	printf "`gettext 'No backups to list.'`\n"
fi

for backup in $backups 
do
	backupFile=`echo $backup | cut -d'$' -f 1`
	backupLog=`echo $backup | cut -d'$' -f 2`
	backupLevel=`echo $backup | cut -d'$' -f 3`
	backupSuccess=`echo $backup | cut -d'$' -f 4`
	type=`echo $backupLog | grep -oiP 'ftp|hdd|usb'`
	
	if [[ $(echo $backupSuccess | grep -cP '^[0-9]+$') -eq 0 ]];then
                backupworked="Not Available"
        elif [[ $backupSuccess -eq 0 ]];then
                backupworked="true"
        else
                backupworked="false"
        fi

    echo $backupFile" Type="$type" Level="$backupLevel" Success="$backupworked
done

/opt/ibm/director/vmi/bin/execWithPrivilege auditLogger listBackups 0
