#!/bin/bash
#
# Licensed Materials - Property of IBM
#
# OCO Source Materials
#
# (C) Copyright IBM Corp. 2011 All Rights Reserved
#
# The source code for this program is not published or other-
# wise divested of its trade secrets, irrespective of what has
# been deposited with the U.S. Copyright Office.
#

DATA_INTERFACE="eth1"
MGMT_INTERFACE="eth0"
CONFIG_FILE_DIR="/etc/xinetd.d/"

export PATH=/usr/bin:/usr/sbin:/bin:$PATH

port=$1
echo $(date)" #####START removePort.sh#####" >> /root/pfdbglog.txt
echo $(date)" port:"$port >> /root/pfdbglog.txt

source_host=$(iptables -L $DATA_INTERFACE-FIREWALL-SETTING  | grep -n $port | cut -d':' -f 1)
for host in $source_host
do
	# host is the line number from the iptables output and there are two lines of stuff at the front of that output that we don't care about
	host=$(($(iptables -L $DATA_INTERFACE-FIREWALL-SETTING  | grep -n -m 1 $port | cut -d':' -f 1)-2))
	iptables -D $DATA_INTERFACE-FIREWALL-SETTING $host
	ip6tables -D $DATA_INTERFACE-FIREWALL-SETTING $host
done

#iptables -D $DATA_INTERFACE-FIREWALL-SETTING -p tcp -i $DATA_INTERFACE --dport $port -j ACCEPT -m state --state NEW,ESTABLISHED,RELATED
#ip6tables -D $DATA_INTERFACE-FIREWALL-SETTING -p tcp -i $DATA_INTERFACE --dport $port -j ACCEPT -m state --state NEW,ESTABLISHED,RELATED

# Cleanup xinetd configuration changes here
rm -f $CONFIG_FILE_DIR$port

# Get the process ID of xinetd 
xinetd_pid=$(ps axuww | grep -i xinetd | grep -v grep | sed 's/^[[:space:]]*//;s/[[:space:]]*$//;s/[[:space:]]\+/,/g' | cut -d',' -f 2)
if [[ $(ps axuww | grep -i xinetd | grep -v grep | wc -l) -eq 0 ]]; then
	#xinetd is not running, so start it
	/etc/init.d/xinetd start
else 
	#xinetd is already running, so send it the signal to refresh itself
	#This will force xinetd to read the updated configuration files without killing the existing process, so existing port forwarding sessions continue to work
	kill -SIGHUP $xinetd_pid
fi
