#! /bin/bash
#
# Licensed Materials - Property of IBM
#
# OCO Source Materials
#
# (C) Copyright IBM Corp. 2013 All Rights Reserved
#
# The source code for this program is not published or other-
# wise divested of its trade secrets, irrespective of what has
# been deposited with the U.S. Copyright Office.
#

export TEXTDOMAINDIR=/usr/share/locale
export TEXTDOMAIN=rmTunnelPort
. /usr/bin/gettext.sh

export PATH=/usr/bin:/bin:$PATH

if [[ $# -ne 1 || "$1" == "-h" || "$1" == "--help" ]];then
	printf "`gettext 'Usage: rmEndpointConnection port\n\nExample:\n\t rmEndpointConnection 61630\n\nUse lsEndpointConnections to get a list of the currently open tunneling ports.'`\n"
	exit 1
fi

/opt/ibm/director/vmi/bin/execWithPrivilege removePort.sh "$@"
rc=$?
/opt/ibm/director/vmi/bin/execWithPrivilege auditLogger rmTunnelPort $rc

if [[ $rc -eq 0 ]];then
	printf "`gettext 'Port removed successfully'`\n"
fi
