//>>built
// NLS_CHARSET=UTF-8
define("fsm/Pages/userMgmt/nls/en/UserMgmtResources", {

  OK : "OK",
  Cancel : "Cancel",
  Close : "Close",
  Name : "Name",
  Description : "Description",
  Password : "Password",
  ConfirmPassword : "Confirm password",
  CurrentPassword : "Current password",
  NewPassword : "New password",
  UsersAndGroupsTitle : "Users and Groups",
  UsersTabTitle : "Users",
  UserGroupsTabTitle : "User Groups",
  GeneralTabTitle : "General",

  //Password validator messages
  PasswordLength : "Password is at least ${0} characters",
  PasswordThreeCharactersRule : "No more than three of the same characters used consecutively",
  PasswordDoesNotRepeatUserIDRule : "Does not repeat or reverse the associated user ID",
  PasswordAtLeastTwoCharactersDifferentFromPreviousPasswordRule : "Password must contain 2 characters not included in the old password.",
  PasswordAtLeastThreeRule : "At least three of the following characters in any combination:",
  PasswordLowercaseAlphabeticCharacterRule : "Lowercase alphabetic character",
  PasswordUppercaseAlphabeticCharacterRule : "Uppercase alphabetic character",
  PasswordNumericCharacterRule : "Numeric character",
  PasswordSpecialCharacterRule : "Special character",
  PasswordAndConfirmPasswordMustMatchRule : "Password and Confirm Password values must match.",

  //User Tab Panel
  UserName : "User Name",
  UserCredentials : "User Credentials",
  UserPermissionTableTitle : "Select User Permission",
  UserGroupsTableTitle : "Select the groups to add this user to",
  AssignIMMRole : "Assign IMM Role",
  UserNameMustBeEnteredRule : "A user name must be entered.",
  CurrentPasswordMustBeEnteredRule : "A current password must be entered.",

  //User Groups Tab Panel
  UserGroupName : "User group name",
  UsersTableTitle : "Select the users to add to this group",
  DeleteUserGroupsConfirmationText : "Are you sure you want to delete the selected user groups?",
  UserGroupTableColumn : "User Group",

  //Add User
  PermissionGroup : "Permission Group",
  Authority : "Authority",
  Scope : "Scope",
  SupervisorGroup : "Supervisor Group",
  OperatorGroup : "Operator Group",
  Default : "Default",
  Supervisor : "Supervisor",
  Operator : "Operator",
  AllChassisComponents : "All Chassis Components",
  LimitedChassisComponents : "Limited Chassis Components",

  //Edit User

  //Delete User
  DeleteUserDialogTitle : "Delete",
  DeleteUserConfirmationText : "Are you sure you want to delete user '{0}'?",
  DeleteUsersConfirmationText : "Are you sure you want to delete the selected users?",
  UsersTableColumn : "User",

  //Lock User
  LockUserDialogTitle : "Lock User",
  LockUserText : "Are you sure that you want to lock the following user accounts: ${0} ?",

  //Unlock User
  UnlockUserDialogTitle : "Unlock User",
  UnlockUserText : "Are you sure that you want to unlock the following user accounts: ${0} ?",

  //Reset Password
  ResetPasswordDialogTitle : "Reset Password",
  ResetPasswordInitialText : "Provide the new password for user: ${0} ",
  ResetPasswordWarningText : "This password will be set to &quot;expired&quot; and must be changed the first time the user attempts to log in.",

  //Snmp User
  TabTitle : "SNMP Users",
  SnpmUserPanelTitle : "SNMPv3/IPMI Accounts",
  SnmpUserDescription : "View, create, modify or delete SNMPv3/IPMI accounts.  Accounts are provisioned to chassis configured for centralized management of SNMPv3/IPMI.",
  SnmpUserLearnMore : "Learn more about SNMPv3/IPMI accounts.",

  //Add/Edit Snmp User
  CreateSnmpUser : "Create SNMPv3/IPMI Account",
  CreateEditSnmpUserDesciption : "Specify SNMPv3/IPMI credentials and select which chassis to provision. Accounts can be provisioned to all current and future centrally managed chassis, or they can be provisioned one chassis at a time.",
  SnmpUserName : "User name:",
  SnmpPassword : "*Password",
  SnmpConfPassword : "*Confirm password",
  ContextName : "Context name:",
  AuthProtocol : "Authentication protocol:",
  AuthProtocolNone : "None",
  AuthProtocolMD5 : "Hash-based Message Authentication Code (HMAC) - Message Digest algorithm 5 (MD5)",
  AuthProtocolSHA : "Hash-based Message Authentication Code (HMAC) - Secure Hash algorithm 5 (sha1-96)",
  PrivProtChkBox : "Use privacy protocol",
  PrivProtAES : "Advanced Encryption Standard (AES128)",
  PrivProtDES : "Cipher Block Chaining (CBC) - Data Encryption Standard (DES)",
  PrivPassword : "*Privacy password",
  PrivConfPassword : "*Confirm privacy password",
  Access : "Access:",
  AccessGet : "Get",
  AccessSet : "Set",
  AccessTrap : "Trap",
  IPAddHostName : "IP address or host name for traps:",
  ProvChkBox : "Provision all current and future chassis",
  ChassisProv : "Chassis Provisioned",
  ProvTable : "Select which chassis to provision with this SNMPv3/IPMI account.  Only chassis "
      + "with centralized SNMPv3/IPMI account management are shown.",
  ProvChassisTooltip : "\"Provision all\" unchecked because it is incompatible with selecting individual chassis.",

  //Edit Snmp User
  EditSnmpUser : "Edit SNMPv3/IPMI Account",
  CurrentSnmpPassword : "*Current password",
  CurrentPrivPassword : "*Current privacy password",

  //Validation
  UsernameReq : "You must enter a user name.",
  // Since lang.replace is used instead of string.substitute, '$' in front of {#} is not needed
  UsernameValidationErrorMsg:  "The user name cannot exceed {0} characters.  Only alphanumeric characters, \"-\", or \"_\" are allowed, and the first character must be alphanumeric.",
  ContextnameValidationErrorMsg : "The context name can only contain alphanumeric characters and cannot exceed {0} characters.",
  PWsMustMatch : "Password and Confirm Password values must match.",
  PwOutOfRangeValueMsg : "Password is at least {0} characters and no longer than {1}.",
  CurrentPwReq : "You must enter a current password.",
  IncorrectCurPw : "The current password entered is not correct.",
  PwMustBeDifFromPrev : "The password entered must be different from the previous password.",
  PwExpired : "Password has expired.  User must change password.",
  IPAddHostnameTooltip : "This value must be an IPv4 or IPv6 address or a fully qualified hostname.",
  
  //Warning NIST Message Dialog for SNMP
  WarningTitle : "Use NIST 800-131A Strict Compliance Settings?",
  WarningMsg1 : "One or more selected chassis are using NIST Strict Mode security and require strict mode-compliant settings:",
  WarningMsg2 : "The following account settings will be modified to comply with the NIST 800-131A security level:",
  WarningSHA : "Hash Message Authentication Code:  sha1-96",
  WarningAES : "Encryption Algorithm:  AES128",

  //CMM and IMM Roles
  NetworkingAndSecurity : "Networking and security",
  UserAccountManagement : "User account management",
  RemoteConsoleAccess : "Remote console access",
  RemoteConsoleAndRemoteDisk : "Remote console and remote disk",
  RemoteServerPowerAndRestartAccess : "Remote server power and restart access",
  BasicAdapterConfiguration : "Basic adapter configuration",
  ClearEventLogs : "Clear event logs",
  AdvancedAdapterConfiguration : "Advanced adapter configuration",
  CmmRolesTabTitle : "CMM Roles",
  ImmRolesTabTitle : "IMM Roles",
  Permissions : "Permissions",
  SelectAllPermissions : "Select All Permissions",
  ChassisOperator : "Chassis operator",
  ChassisUserAccountManagement : "Chassis user account management",
  ChassisLogAdministration : "Chassis log administration",
  ChassisConfiguration : "Chassis configuration",
  ChassisAdministration : "Chassis administration",
  BladeOperator : "Blade operator",
  BladeRemotePresence : "Blade remote presence",
  BladeConfiguration : "Blade configuration",
  BladeAdministration : "Blade administration",
  IOModuleOperator : "I/O module operator",
  IOModuleConfiguration : "I/O module configuration",
  IOModuleAdministration : "I/O module administration",
  Resources : "Resources",
  SelectAllResources : "Select All Resources",
  Chassis : "chassis",
  Bay1 : "bay01",
  Bay2 : "bay02",
  Bay3 : "bay03",
  Bay4 : "bay04",
  Bay5 : "bay05",
  Bay6 : "bay06",
  Bay7 : "bay07",
  Bay8 : "bay08",
  Bay9 : "bay09",
  Bay10 : "bay10",
  Bay11 : "bay11",
  Bay12 : "bay12",
  Bay13 : "bay13",
  Bay14 : "bay14",
  IOBay1 : "iobay01",
  IOBay2 : "iobay02",
  IOBay3 : "iobay03",
  IOBay4 : "iobay04",
  DeleteCustomRolesText : "You have selected to delete these roles. Users assigned to these roles will no longer have access to permissions defined by these roles. Click OK to delete the roles, or Cancel to retain them.",
  cmmRoleTitle : "CMM Role",
  immRoleTitle : "IMM Role"

});
