var resourceTabInitTimeout;
var chassisMapLoadFailSafe = false; //This turns to true eventually when chassis map dojo dependencies are loaded
var dojoLoadCounter = 0; // This gets incremented during initial page load as dojo libraries come in, useful to track if dojo is just loading slowly, or not there at all
var lastLoadCounter = 0; // used to compare load counter between intervals, to see if dojo broke or it's just loading slowly
function resourceTabInit() {
  phxTrace("resourceTabInit called");
  if (!resourceTabInitTimeout)
    resourceTabInitTimeout = setTimeout(resourceTabInit_impl, 150);
  if(document.getElementById("fakeChas")) {
	document.getElementById("fakeChas").innerHTML = "<div style=\"background: url('/com.ibm.itme.console/images/processing.gif')" + 
	      " no-repeat scroll 0 0 transparent; height: 18px; padding-left: 18px;\"> Loading... </div>";  
	}
  require(["dojo/ready"], function (ready) {
	dojoLoadCounter++;
	ready( function() {
	 chassisMapLoadFailSafe = true;	 
	});
  });

}
function checkChassisMapLoadFailSafe() {
	if(chassisMapLoadFailSafe === false) {
		if(lastLoadCounter < dojoLoadCounter) {
			lastLoadCounter = dojoLoadCounter;
			setTimeout(checkChassisMapLoadFailSafe, 5000);
		} else {
			document.forms[0].submit();			
		}
	}
}

function resourceTabInit_impl() {
  phxTrace("resourceTabInit_impl");
  resourceTabInitTimeout = null;
  delete Object.prototype.toJSONString;
  delete Array.prototype.toJSONString;
  require(["dojo/ready", "dojo", "dojo/parser", "dojo/query", "fsm/Utils/itmeUtils", "fsm/Widgets/ISCCommonActionsMenu", "fsm/Widgets/finder/FinderMain"], 
  function (ready, dojo, parser, query, Utils, commonActionsMenuClass, finderLoader) {
	  dojoLoadCounter++;
      //Utils.unSetBadPrototypes(); // prevents dojo breakage from .toJSONString in jsp pages.
      ready( function() {
        loaded = true;
        
        removePageWhiteSpace();
                
        parser.parse();
    
        finderNodeId = viewId + ":" + "helloWorld_mainForm" + ":" + "chassisListSubview";
        // Load finder
          try {
            //var asdf = new finderLoader();
            finderLoader.createFinder(finderNodeId, "finder");
            //alert("inInit");
            positionFinder_impl();
          } catch (error) {                
            Utils.CMError("error loading finder: " + error);
          }
        
        // Load context finder  
          // Redesign: remove context finder
          //var finderNodeId = viewId + ":" + "helloWorld_mainForm" + ":" + "chassisListSubview";
          //finderLoader.createContextFinder(finderNodeId, "contextFinder");          
        // Load common actions menu
    
        //setTimeout("queryTableElements()", 500);
      });
  });
}

function removePageWhiteSpace() {
  phxTrace("removePageWhiteSpace");
  delete Object.prototype.toJSONString;
  delete Array.prototype.toJSONString;
  require(["dojo/ready", "dojo/has"], 
  function (ready,  has) {
    dojoLoadCounter++;
      ready( function() {
        
        //begin- fix positioning by detecting when director message widget is present,
        //move the chassis map down. When it is not present, reset it back to its origianl place
        var IEVersion = has("ie");
        var element;
        
        // fix position of page in ISC
        if( IEVersion ) { // only IE6 and below
          element = document.body.childNodes[0];
          if ( IEVersion == 8 || IEVersion == 7)  {        
            if(element.nodeName == "DIV" || element.nodeName == "div" || element.nodeName == "Div") {
              element.style.margin = "-32px 0px 0px 0px";      
            } 
          } else {
            if(element.nodeName == "DIV" || element.nodeName == "div" || element.nodeName == "Div") {
              element.style.margin = "-20px 0px 0px 0px";                    
            }  
          }
        } else {
           document.getElementById(viewId + ':helloWorld_mainForm').style.margin = "-20px 0px 0px 0px";  
        }
           
      });
  });
}


var createGeneralActionsTimeout;
function createGeneralActions() {
  phxTrace("createGeneralActions called");
  if (!createGeneralActionsTimeout)
    createGeneralActionsTimeout = setTimeout(createGeneralActions_impl, 150);
}

function createGeneralActions_impl() {
  phxTrace("createGeneralActions_impl");
  createGeneralActionsTimeout = null;
  delete Object.prototype.toJSONString;
  delete Array.prototype.toJSONString;
  require(["dojo/ready", "dojo", "fsm/Utils/itmeUtils", "fsm/Widgets/ISCCommonActionsMenu"], // called directly from jsp, make sure dom is ready before execution
  function (ready, dojo, Utils, commonActionsMenuClass) {
	  dojoLoadCounter++;
      ready(function() {
        var parentDomNodeId, commonActionMenu;
  
        //Utils.unSetBadPrototypes(); // prevents dojo breakage from .toJSONString in jsp pages.
        
        Utils.CMTrace("Adding General Actions menu");
        parentDomNodeId = viewId + ":" + "helloWorld_mainForm" + ":" + "chassisListSubview";
        commonActionMenu = new commonActionsMenuClass({}, parentDomNodeId);
        commonActionMenu.createCommonActionsMenu();
      });
 });
}

function closeChassisMapDropDown() {
  phxTrace("closeChassisMapDropDown");
  var dropDown = document.getElementById(viewId + ':helloWorld_mainForm:chassisListSubview:chassisChoiceDropDownBox');
  if(dropDown) {
  	dropDown.blur();
  }
}

var positionFinderTimeout;
function positionFinder() {
  phxTrace("positionFinder called");
  if (!positionFinderTimeout)
    positionFinderTimeout = setTimeout(positionFinder_impl, 150);
}

function positionFinder_impl() {
  phxTrace("positionFinder_impl");
  positionFinderTimeout = null;

  delete Object.prototype.toJSONString;
  delete Array.prototype.toJSONString;

  require(["dojo/ready", "dojo", "dojo/dom-geometry", "fsm/Utils/itmeUtils"], // called directly from jsp, make sure dom is ready before execution 
  function (ready, dojo, djDomG, Utils) {
	  dojoLoadCounter++;
      ready(function() {
        //Utils.unSetBadPrototypes(); // prevents dojo breakage from .toJSONString in jsp pages.
        
        Utils.CMDEBUG("positionFinder - function");  
        var finderDomobj, placeholder, position, x, greatestLength = 0, options, idx;
      
        //Make sure chassis map is hidden if we go to chassis list
        try {
          if(document.getElementById('finderStartPosition')) {
            if(document.getElementById('ChassisMapHiddenContainer').style.display != 'none') {
              document.getElementById('ChassisMapHiddenContainer').style.display='none';
              shouldRefreshChassisMapDom = true;
              previousHomeParm = '';
              cleanUpChassisMap();
            }
          }
        } catch (e) {}
         
        finderDomobj = document.getElementById('finderTableEl');
        placeholder = document.getElementById('finderStartPosition');              
        if(placeholder) { //Means we're in chassis list
          placeholder = (placeholder.parentNode.parentNode.firstChild.firstChild);   
          position = djDomG.position(placeholder, true);                  
          x = position.w + position.x + 20;   
          finderDomobj.style.left = x;            
        } else { //Means we're in chassis map
          //First, resize combobox
          try {
            options = document.getElementById( viewId + ":" + "helloWorld_mainForm" + ":" + "chassisListSubview" + ":chassisChoiceDropDownBox").options;   
            for(idx = 0; idx < options.length; idx++) {
              if(options[idx].text.length > greatestLength) {
                greatestLength = options[idx].text.length;
              }
            }
            if(greatestLength > 35) {
              document.getElementById( viewId + ":" + "helloWorld_mainForm" + ":" + "chassisListSubview" + ":chassisChoiceDropDownBox").style.width = "300px";
            }
          } catch (error) { }
          placeholder = document.getElementById('finderStartPosition2');  
          if(placeholder) {
            position = djDomG.position(placeholder.previousSibling, true);
            x = position.w + position.x + 20;
            finderDomobj.style.left = x;  
          }
        }
      });
  });
} 

function processRefresh(id) {
  require(["dojo", "fsm/Utils/itmeUtils"],
    function (dojo, Utils) {
	  dojoLoadCounter++;
      
        // uses global 'viewId' defined in resourceTab
        var hiddenSelectedInputText, currentHiddenValue, jsFlightLogField, shouldRefreshChassisMapDom, prevId;
      
        Utils.CMTrace("Process Refresh : " + id);
        if(id == 'dataRefreshed') {
          return;
        }
      
        hiddenSelectedInputText = document.getElementById(viewId + ':helloWorld_mainForm:chassisListSubview:hiddenSelectedText');
        jsFlightLogField = document.getElementById(viewId + ':helloWorld_mainForm:chassisListSubview:hiddenJSFlightLogData');
        jsFlightLogField.value = "";
        
        shouldRefreshChassisMapDom = false;
        // valid action ids
        //  = 'goback'
        //  - 'tableView'
        //  - 'tableView_cmerror'+<error message>
        //  - 'graphicalView'
        //  - 'swapChassis'+<chassisId>
        //  - 'nodata'   (indicates an unmanage or hwView failure)
        //  - 'refresh'  (indicates a js hsView widget refresh)
        //  - <selection id>
      
        if(id == 'toggleProperties') {
          hiddenSelectedInputText = document.getElementById(viewId + ':helloWorld_mainForm:chassisListSubview:togglePropertiesValue');
          hiddenSelectedInputText.value = 'true';
        }
        else if(id == 'goback' || id == 'unmanaging') {
          document.getElementById('ChassisMapHiddenContainer').style.display='none';
          document.getElementById(viewId + ':helloWorld_mainForm:chassisListSubview:selectedChassisMapOidsCSV').value = 'goback';
          shouldRefreshChassisMapDom = true;
        }
        else if(id == 'swapChassis') {
          chassisId = document.getElementById(viewId + ':helloWorld_mainForm:chassisListSubview:chassisChoiceDropDownBox').value;
          hiddenSelectedInputText.value = id + chassisId;
          phxTrace(" - hiddenInputValue: " + hiddenSelectedInputText.value);
          shouldRefreshChassisMapDom = true;
        }
        else if(id.indexOf('tableView') != -1) {
          document.getElementById('ChassisMapHiddenContainer').style.display='none';    
          shouldRefreshChassisMapDom = true;
          if ( Utils.FSMFlightRecorder && (id.indexOf('cmerror') > 0) )
            jsFlightLogField.value = Utils.FSMFlightRecorder.toString();
        }
        else if(id == 'graphicalView') {
          shouldRefreshChassisMapDom = true;   
        }
        else if(id == 'nodata') {
          document.getElementById('ChassisMapHiddenContainer').style.display='none';
          shouldRefreshChassisMapDom = true;   
        }
  
        
        prevId = hiddenSelectedInputText.value;
        if(prevId == id) {
          //disabled the deselection function when an item that's already selected gets clicked again
            //hiddenSelectedInputText.value = 'clearselection';
              return;
        } else {
          hiddenSelectedInputText.value = id;       
        }
        if(shouldRefreshChassisMapDom) {
          previousHomeParm = '';
          cleanUpChassisMap();
        }
      document.getElementById(viewId + ':helloWorld_mainForm:chassisListSubview:ajaxButton').click(); 
    }
  );
}

function switchToGraphicalView() {
  setSelectionCookieInChassisMap();
  processRefresh('graphicalView');
}

function setSelectionCookieInChassisMap() {  
  require(["dojo/cookie"], 
    function (djCookie) {
	  dojoLoadCounter++;
      var hiddenSelectedInputText = document.getElementById(viewId + ':helloWorld_mainForm:chassisListSubview:selectedChassisMapOidsCSVReadOnly');
      var list = hiddenSelectedInputText.innerHTML;  
    
      phxTrace("COOKIE: adding cookie to set selection to: " + list);
      djCookie("chasisMap.currentSelection", list, { expires: 1});
    }
  );
}

function hideProperties() {
  var tables = document.getElementsByTagName('table');
  var i;
  for(i = 0; i < tables.length; i++) {
    if(tables[i].id != null && tables[i].id.indexOf('chassis:PROPERTIES:propsHeaderBox') != -1) {
      tables[i].style.display = 'none';
      propertiesTableDetails = tables[i];
    }
  } 
  setTimeout("queryTableElements()", 500);
}
  
function queryTableElements() {
  //phxTrace("queryTableElements()");
  require(["dojo/_base/lang"], function(djLang) {    
	dojoLoadCounter++;
    var actionsHolder, spans, i, menuObj, inputChild;
    //alert("inQueryTableEls");
    positionFinder();
    actionsHolder = document.getElementById("actionsHolder");
    if(actionsHolder == null) {
      return;
    }
    
    spans = document.getElementsByTagName('span');
    for(i = 0; i < spans.length; i++) {
      if(spans[i].id != null && spans[i].id.indexOf('chassis:PROPERTIES:DisplayName_propComponent_menu_SPAN') != -1) { 
        //if ( actionsHolder.hasChildNodes() ) {
        //    while ( actionsHolder.childNodes.length >= 1 ){
        //        actionsHolder.removeChild( actionsHolder.firstChild );   
        //    }
        //}              
        //var clone = spans[i].cloneNode(true);
        //clone.id = clone.id + "clone";
        menuObj = spans[i];
        actionsHolder.appendChild(menuObj); 
        
        //force property change so that director's actions dropdown repositions arrow 
        inputChild = menuObj.firstChild;  
        inputChild.title = inputChild.title + " ";  
        inputChild.title = djLang.trim( inputChild.title );  
        
        break;                         
      }
    }
  });
}

function toggleDetails(img) {
  //phxTrace("toggleDetails("+img+")");
  var imgName = img.src;
  if(imgName.indexOf("arrowOpen") != -1) {
    img.src = "/com.ibm.itme.console/images/arrowClosed.jpg";
    propertiesTableDetails.style.display = 'inline';
  } else {                        
    img.src = "/com.ibm.itme.console/images/arrowOpen.jpg";
    propertiesTableDetails.style.display = 'hidden';
  }
  
}

var lcmTimeout = null;
// uses global 'chassisMapViewID' defined in chassisMap.jsp
function loadChassisMap()
{ 
  phxTrace("loadChassisMap" );
  var chassisMapElm, userAgent, nodeId, chassisHomeParmsId, chassisSelectionId, homeParmsValue, 
      elementSelectionValue, comboBox, valueField, i;
  chassisMapElm = document.getElementById('ChassisMapHiddenContainer');
  if(chassisMapElm == null) {
    loaded = false;
  } else {
    chassisMapElm.style.display='inline';
    userAgent = navigator.userAgent;
    loaded = true;
  }
  setSelectionCookieInChassisMap();
  phxTrace("loadChassisMap:  jsp Loaded?: " + loaded );
  if ( !loaded )
    lcmTimeout = setTimeout(loadChassisMap, 500);
  else {
    clearTimeout(lcmTimeout);
    nodeId = chassisMapViewID + ":" + "helloWorld_mainForm" + ":" + "chassisListSubview" + ":" + "chassisMapBox";
    chassisHomeParmsId = chassisMapViewID + ":" + "helloWorld_mainForm" + ":" + "chassisListSubview" + ":" + "chassisMapHomeParms2";
    chassisSelectionId = chassisMapViewID + ":" + "helloWorld_mainForm" + ":" + "chassisListSubview" + ":" + "hiddenSelectedText";
    homeParmsValue = document.getElementById(chassisHomeParmsId).innerHTML;
    elementSelectionValue = document.getElementById(chassisSelectionId).value;
    //phxTrace("TMP: selection Value: " + elementSelectionValue);
    if(chassisHomeParmsId == previousHomeParm) {
      return;
    } else {
      previousHomeParm = chassisHomeParmsId;
    }
    temphack = temphack + 1; //Seems a bug on nav widget, won't refresh unless homeparms are different
    launchChassisMap("ChassisMap", nodeId, Math.floor(Math.random()*50000) + '#' + homeParmsValue, elementSelectionValue);
  }
  comboBox   = document.getElementById(chassisMapViewID + ':helloWorld_mainForm:chassisListSubview:chassisChoiceDropDownBox');
  valueField = document.getElementById(chassisMapViewID + ':helloWorld_mainForm:chassisListSubview:chassisMapHomeParms2').innerHTML;

  if ( comboBox ) {
    for(i = 0; i < comboBox.options.length; i++) {
       if(comboBox.options[i].value == valueField) {
          comboBox.options[i].selected="selected";
       } else {                     
           comboBox.options[i].selected=null;
       }
    }
  }
  
}

function handleError(error) {
  phxTrace("FAIL:" +  error);
}

//dojo.provide("itme.itmeUtils");

// TODO:
// 1. Clean code
//  a. Seperate out Overlays and Selection behaviors from Chassis Map
//  b. super / sub class the overlays

// GLOBAL (Non Scoped) =============================    
  TRACE_INFO= [];
  TRACE_INFO.LAYOUT = false;
  TRACE_INFO.OVERLAY = false;
  TRACE_INFO.SELECTION = false;
  TRACE_INFO.MAIN = true;
  TRACE_INFO.CA_MENU = false;
  
  

var chassisMap;
// Temporary.  The intent is that this should be in the jsp (here for speed of development keeping it out of the jsp)
function launchChassisMap(ChassisMapParentDOMNodeID, nodeIdToGetSizeFrom, chassisId, selectedElementsByItemId){
  phxTrace("launchChassisMap - ChassisId: " + chassisId);
  setTimeout(checkChassisMapLoadFailSafe, 5000);
  require(["dojo/ready", "dojo", "dojo/has", "dojo/_base/unload", "fsm/Widgets/ChassisMap/CuriDirectorDataInterface", "fsm/Widgets/ChassisMap/ChassisMap"], 
    function (ready, dojo, has, djUnload, fsmCuriDataInterface, fsmChassisMap) {
	  dojoLoadCounter++;
	  ready(function() {
		  chassisMapLoadFailSafe = true;
		  if(document.getElementById("fakeChas")) {
			   document.getElementById("fakeChas").innerHTML = "";
			 }
		  var curiDataInterface;
	      
	      if ( has("ie") )
	        djUnload.addOnWindowUnload(chassisMapWindowUnload);
	      else
	        djUnload.addOnUnload(chassisMapPageUnload);
	      
	      curiDataInterface = new fsmCuriDataInterface({
	        targetDataset : "CHASSIS_MAP_COLLECTION"
	      });
	      curiDataInterface.setRequestTarget(chassisId);

	      //phxTrace("chassisMap?: " + chassisMap);
	      if (chassisMap == null) {
	        
	 
	        
	        chassisMap = new fsmChassisMap({         
	                                         selectionCallback: onHWViewSelection,
	                                         contextMenuHandler: "isc"
	                                         //resizeToFitParent: true,
	                                         //shownOverlays: ["status", "updates", "name"],
	                                         //asynchOverlayData: [ "updates" ] 
	                                       },
	                                       ChassisMapParentDOMNodeID, // parent DOM Node
	                                       curiDataInterface); // data interface
	        if (nodeIdToGetSizeFrom )
	          chassisMap.setDimensionsBasedOnNode(dojo.byId(nodeIdToGetSizeFrom), true);
	        
	        chassisMap.startup();
	      }
	      else
	        phxWarn("Chassis map already rendered, NOT going to re-render");
	  });
     
    });
}

function onHWViewSelection(itemObjects) {
  var i, csvIdString = "";
  //phxTrace("onHWViewSelection");
  require(["dojo"], function (dojo) { 
	dojoLoadCounter++;
    if ( dojo.isArray(itemObjects) ) {
      for (i = 0; i < itemObjects.length; i++) {
        if (i >= 1)
          csvIdString += ",";
        csvIdString += itemObjects[i].getId();
      }
    } else
      csvIdString = itemObjects;
  });
  processRefresh(csvIdString);
}

function phxTrace(strOutput)
{
  //FSMFlightRecorder.add(strOutput);
  try {
    console.log(strOutput);
  } catch(e) { }
}

function phxWarn(strOutput)
{
  //FSMFlightRecorder.add("WARNING - " + strOutput);
  try {
    console.warn(strOutput);
  } catch(e) { }
}

function phxError(strOutput)
{
  //FSMFlightRecorder.add("!ERROR! - " + strOutput);
  try {
    console.error(strOutput);
  } catch(e) { }
}

function cleanUpChassisMap()
{
  phxTrace("cleanUpChassisMap");
  if ( typeof(chassisMap) != "undefined" && (chassisMap != null)) // when table view is loaded, clean up 
    chassisMap.destroy();
  chassisMap = null;
}

function chassisMapPageUnload()
{ 
  phxTrace("page unload, cleaning up chassis map");
  // call the code that sets up a refresh
  cleanUpChassisMap(); 
  //dojo.cookie("chasisMap.currentOverlay", null, {expires: -1});
}

function chassisMapWindowUnload() {
  phxTrace("window unload, cleaning up chassis map");
  // call the code that sets up a refresh
  cleanUpChassisMap(); 
}

//function testWindowUnload() {
//  phxTrace("TEST - window unload");
//}

var itmeUtils = {
		
  // Used to decouple some 'requires' calls from the jsp for faster development.  Once calls are finalized, may as well 
  // move to jsp
  externalLoadRequires: function() {
    
  },

  CMTrace: function (codePath, outputText) {
    if (TRACE_INFO[codePath] === false) // if the codepath is part of the array, and true 
      return;
    if (!TRACE_INFO[codePath])
      phxTrace(outputText);
    else if (TRACE_INFO[codePath] === true)
      phxTrace(codePath + " - " + outputText);
  },
  CMWarn: function (codePath, outputText) {
    phxWarn(codePath + " - " + outputText);
  },
  CMError: function (codePath, outputText) {
    phxError(codePath + " - " + outputText);
  },
  

  _myTimers: [],
  initializeTimer: function (timerName) { 
    this._myTimers[timerName] = new Date(); 
  },

		
  // make a page element visible
  showPageElement: function(elName) {
    var tbl = document.getElementById(elName);
    tbl.style.display = 'block'; // consider if using for text elements "inline"
  },

  // hide a page element
  hidePageElement: function (elName) {
    var tbl = document.getElementById(elName);
    tbl.style.display = 'none';
  },
		
  traceTimeDelta: function (timerName, deltaMessage, bRestartTimer) {
    if (this._myTimers[timerName]) {
      var now = new Date();
      phxTrace(deltaMessage + " : " + (now - this._myTimers[timerName]) + "ms");
    }
    if (bRestartTimer === true)
      this._myTimers[timerName] = new Date();
  },
		
  getProperty: function (item, propertyName) {
    var propValue = null;
    try {
      var prop = item.getProperty(propertyName);
      if (prop) {
        propValue = prop.getValue();
      }
    } 
    catch (err) {
      phxTrace("an error occurred getting properties for " + item.getLabel() + " : " + err);
    }
    return propValue;
  },
		
  isChrome: function () {
    return (navigator.userAgent.toLowerCase().indexOf('chrome') > -1);
  },
		
  // creates and returns the element
  /* parmameters:
   * elementType: html element type "span", "div", etc.. (DEFAULT: DIV)
   * styleClass: "one or more style classes seperated by a space"
   * style: object containing html style info.  Used as dojo.attr(<>,"Style",style)
   * parentNode: append this element to...
   * baseDimensionsOnNode: set default dimensions based on node...:
   * innerHTML: a string that will be put within the elements opening and closing tags
   */
  createElement: function(elementId, parentNode, parms) {
    var newElement;
    if (!parms) parms = {};
    var elementType = (parms.elementType) ? parms.elementType : "div";
    
    if (dojo.byId(elementId)) 
      return dojo.byId(elementId);
  
    try {
      newElement = document.createElement(elementType);
      dojo.attr(newElement, "id", elementId);
      if ( parms.styleClass )
        dojo.attr(newElement, "class", parms.styleClass);
      if ( parms.style )
      dojo.attr(newElement, "style", parms.style);

      // IE hack, we have to clone the node and do future work from the clone
      if ( parentNode )
        parentNode.appendChild(newElement.cloneNode(true));
      else
        newElement.cloneNode(true);
      newElement = dojo.byId(elementId);
    } 
    catch (e) {
      phxTrace("error appending new element ("+elementId+"):" + e.message);
    }
    
    if ( parms.baseDimensionsOnNode && newElement ) {
      var sizeToElementCBox = dojo.contentBox(parms.baseDimensionsOnNode);
      dojo.contentBox(newElement, {
        w: sizeToElementCBox.w,
        h: sizeToElementCBox.h
      });
    }
    
    if ( parms.innerHTML )
      newElement.innerHTML = parms.innerHTML;
    
    return newElement;
  },
		
  myJoin: function (theArray, seperator) {
    if (!seperator)
      seperator = ",";
    var first = true;
    var retString = "";
    for (var elementIndex in theArray) {
      if (first === false)
        retString += seperator;
      retString += theArray[elementIndex];
      first = false;
    }
    return retString;
  },
		
  associativeArrayLength: function (theArray) {
    var size = 0;
    for (elementIndex in theArray) 
      size++;
    return size;
  },
		
  //nice way to attach events with params; from http://stackoverflow.com/questions/95731/why-does-an-onclick-property-set-with-setattribute-fail-to-work-in-ie
  makeEvent1Param: function (element, callback, param1, event)
  {
    function local(e) {
        return callback(param1, e);
    }

    if (element.addEventListener) {
        //Mozilla
        element.addEventListener(event,local,false);
    } else if (element.attachEvent) {
        //IE
        element.attachEvent("on"+event,local);
    }
  },
		
  // returns true if control or shift was pressed during the mouseEvent
  isMultiSelectKeyUsed: function(mouseEvent)  {
    //this.CMTrace("SELECTION", "Event test: e.ctrl " + mouseEvent.ctrlKey);
    //this.CMTrace("SELECTION", "Event test: e.shift " + mouseEvent.shiftKey);
    if ( mouseEvent.ctrlKey == true || mouseEvent.shiftKey == true)
      return true;
    return false;
  },
  
  /*
   * Will create a new span element as a child of 'element' parameter containing 'text' ellipsed if necessary
   * parms { // all optional parms
   *  styleClass: will append this style to the new span element
   *  ellipseAt: int index to insert the ellipse at, use for inserting an ellipse at a point within the 'text'
   *  ellipseAfter: string to insert ellipse after, use to insert ellipse at a point within the 'text'
   *  returnOnly: true if we just want the string
   *  }
   */
  insertEllipsedTextSpanIntoElement: function(element, text, parms)
  {
    if ( !parms )
      var parms = {};
    var elementCount = 0;
    var elementId = element.id+"_txtSpan"+elementCount;
    while ( dojo.byId(elementId) ) {
      elementCount++;
      elementId = element.id+"_txtSpan"+elementCount;
    }
  
    var txtSpan = this.createElement(element.id+"_txtSpan", 
                                     element,
                                      {elementType: "span",
                                       styleClass: parms.styleClass,
                                       innerHTML: text});
  
    var width = dojo.contentBox(element).w;

    var wi = dojo.contentBox(txtSpan).w; 
    if(wi > width)
    {
      var i = 1;
      txtSpan.innerHTML = '';
      wi = dojo.contentBox(txtSpan).w;
      while(wi < (width) && i < text.length)
      {
        txtSpan.innerHTML = text.substr(0,i) + '...';
        i++; 
        wi = dojo.contentBox(txtSpan).w;
      } 
      
      if ( parms.insertAfter ) 
        parms.insertAt = text.indexOf(parms.insertAfter) + parms.insertAfter.length;
      if ( parms.insertAt )
        txtSpan.innerHTML = text.substr(0, parms.insertAt) + "..." + text.substr(parms.insertAt, i-2) ;
      else
        txtSpan.innerHTML = text.substr(0,(i-2)) + '...'; // 1 less than what sent us over the size limit
    }
    
    if ( parms.returnOnly ) {
      var returnStr = txtSpan.innerHTML;
      dojo.destroy(txtSpan);
      return returnStr;
    }
  },

  splitFRMDividedProperty: function (item, propName) {
    var dataArray = [];
    var property = this.getProperty(item, propName);
    if ( property ) {
      this.CMTrace("OVERLAY", propName + ": " + property);
      var propList = property.split("-,-");
      for (i = 0; i <  propList.length; i++) {
        if ( propList[i] != "")
        {
          this.CMTrace("OVERLAY", "Property : " + propList[i]);
          keyValuePair = propList[i].split("=");
          if ( keyValuePair[1] )
            dataArray[keyValuePair[0]] = keyValuePair[1];
        }
      }
    }
    else
      this.CMTrace("OVERLAY", propName + ": was empty or not passed");
    
    return dataArray; 
  }
};
