#
# Licensed Materials - Property of IBM
#
# OCO Source Materials
#
# (C) Copyright IBM Corp. 2010 All Rights Reserved
#
# The source code for this program is not published or other-
# wise divested of its trade secrets, irrespective of what has
# been deposited with the U.S. Copyright Office.
#

#!/bin/bash

# Return Code
#0: Start was successful
#1: Start failed with error
#2: LWI is already running; start failed

LWI_BIN_DIR=/opt/ibm/director/lwi/bin
LAP_BIN_DIR=/opt/ibm/director/lap/bin
LWI_START_OPTION="profile.lap=uimin,uistandard,lap com.ibm.lwi.profile=profile.lap"

# Checking LWI status
STATUS=`${LWI_BIN_DIR}/lwistatus.sh`
if [ ${STATUS} == "ACTIVE" ] ; then
	echo "LWI must be stopped!"
	exit 2
fi

# Starting LWI
RETVAL=0
echo  "Starting LAP LWI..."
nohup ${LWI_BIN_DIR}/lwistart.sh ${LWI_START_OPTION} >/dev/null 2>&1 &
LAP_LWI_PID=`ps -efww|grep "${LWI_START_OPTION}"|grep -v grep|awk {'print $2'}`
RETVAL=$?
if [ $RETVAL -eq 0 ]; then
	STATUS=`${LWI_BIN_DIR}/lwistatus.sh`
	COUNT=0
	while [ "$STATUS" != "ACTIVE" ]; do
		sleep 5
		COUNT=`expr $COUNT + 1`
		STATUS=`${LWI_BIN_DIR}/lwistatus.sh`
		if [ $COUNT -ge 80 ]; then
			echo "LWI is taking too long to start."
			echo "LAP LWI did not start successfully."
			exit 1
		fi
	done
	echo "LAP LWI is started."
else
	echo "Error occurred during starting LAP"
	exit 1
fi

exit 0
