#
# Licensed Materials - Property of IBM
#
# OCO Source Materials
#
# (C) Copyright IBM Corp. 2010 All Rights Reserved
#
# The source code for this program is not published or other-
# wise divested of its trade secrets, irrespective of what has
# been deposited with the U.S. Copyright Office.
#

#!/bin/bash

# Return Code
#0: Stop was successful
#1: Stop failed with error
#2: LWI is not running; stop failed

LWI_BIN_DIR=/opt/ibm/director/lwi/bin
LAP_BIN_DIR=/opt/ibm/director/lap/bin
PLATFORM_XML_FILE=/opt/ibm/director/lwi/conf/org.eclipse.update/platform.xml
PLATFORM_XML_BACKUP_FILE=/opt/ibm/director/lwi/conf/org.eclipse.update/.platform.xml.backup
# Checking LWI status
STATUS=`${LWI_BIN_DIR}/lwistatus.sh`
if [ ${STATUS} != "ACTIVE" ] ; then
	echo "LWI is not running"
	exit 2
fi

# Stop LWI
RETVAL=0
echo  "Stopping LWI..."
nohup ${LWI_BIN_DIR}/lwistop.sh >/dev/null 2>&1 &
if [ $RETVAL -eq 0 ]; then
	STATUS=`${LWI_BIN_DIR}/lwistatus.sh`
	COUNT=0
	while [ "$STATUS" != "INACTIVE" ]; do
		sleep 5
		COUNT=`expr $COUNT + 1`
		STATUS=`${LWI_BIN_DIR}/lwistatus.sh`
		if [ $COUNT -ge 80 ]; then
			echo "LWI is taking too long to stop."
			echo "LAP LWI did not stop successfully."
			exit 1
		fi
	done
	echo "LAP LWI is stopped."
	mv $PLATFORM_XML_BACKUP_FILE $PLATFORM_XML_FILE
	
else
	echo "Error occurred during stopping the LAP LWI"
	exit 1
fi

exit 0
